﻿/*! \file */

#pragma once

#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__) || defined(_WIN64) || defined(__CYGWIN__)
# define ALI_OS_WIN
#elif defined(__ANDROID__)
# define ALI_OS_ANDROID
#elif defined(macintosh) || defined(__APPLE__) || defined(__APPLE_CC__)
# include <TargetConditionals.h>
# if TARGET_OS_IPHONE == 1
#  define ALI_OS_IOS
# else
#  define ALI_OS_MAC
# endif
#elif defined(linux) || defined(__linux) || defined(__linux__)
# define ALI_OS_LINUX
#else
# error "unknown OS"
#endif

#ifdef ALI_OS_WIN
# if defined(_WIN64)
#  define ALI_ENV64
# else
#  define ALI_ENV32
# endif
#endif

#if defined(__GNUC__) || defined(__clang__)
# if defined(__x86_64__) || defined(__ppc64__)
#  define ALI_ENV64
# else
#  define ALI_ENV32
# endif
#endif
